unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.StdCtrls,
  VCLTee.TeEngine, VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart,
  Vcl.Grids;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    Series3: TPointSeries;
    StringGrid1: TStringGrid;
    NEdit: TLabeledEdit;
    NsetBtn: TButton;
    interpolationBtn: TButton;
    testdataBtn: TButton;
    Series2: TPointSeries;
    XEdit: TLabeledEdit;
    XtoYBtn: TButton;
    Series4: TLineSeries;
    GroupBox1: TGroupBox;
    CheckBox2: TCheckBox;
    TestNEdit: TLabeledEdit;
    MinXEdit: TLabeledEdit;
    MaxXEdit: TLabeledEdit;
    RadioGroup1: TRadioGroup;
    procedure testdataBtnClick(Sender: TObject);
    procedure NsetBtnClick(Sender: TObject);
    procedure interpolationBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure XtoYBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure GridSet(Sin, Colin: integer);
    procedure FGridSet(Sin, Colin: integer);    // ObhTCYύX
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

type
  DArray = array of double;


var
  x, y, yd : Darray;
  N : integer;
  dx, xmax, xmin : double;
  FF : boolean;

// ObhTCY̕ύX
procedure TForm1.GridSet(Sin, Colin: integer);    // ObhTCYύX
var                                               // f[^[s̐10
  H, W :integer;                                  // ȏ̓XN[
begin
  if (StringGrid1.ColCount = Colin) and (StringGrid1.RowCount = Sin) then exit;
  StringGrid1.ColWidths[0] := 30;
  StringGrid1.ColCount := Colin;
  StringGrid1.RowCount := Sin;
  if Sin <= 11 then                               // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * Sin;
      W := (StringGrid1.DefaultColWidth + 1) * (Colin - 1) + 31;
      StringGrid1.ScrollBars := ssNone;           // XN[o[Ȃ
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * (10 + 1);
      W := (StringGrid1.DefaultColWidth + 1) * (Colin - 1) + 31;
      StringGrid1.ScrollBars := ssVertical;       // XN[o[\
    end;
  StringGrid1.ClientWidth := W;
  StringGrid1.ClientHeight := H;
end;

// ObhŒs̐ݒ
procedure TForm1.FGridSet(Sin, Colin: integer);
var
  E : integer;
begin
  GridSet(Sin, Colin);
  for E := 1 to Sin - 1 do
      StringGrid1.Rows[E].Text := intTostr(E);
  StringGrid1.Cols[1].Text := 'x';
  StringGrid1.Cols[2].Text := 'y';
end;

// N G[߂l<0
function Ninput(testF: boolean): integer;
var
  N, ch: integer;
begin
  result := -1;
  if not testF then
    val(Form1.Nedit.Text, N, ch)
  else
    val(Form1.testNedit.Text, N, ch);
  if ch <> 0 then begin
    application.MessageBox('N̓͂ɊԈႢL܂B','',0);
    exit;
  end;
  if N > 100 then begin
    application.MessageBox('N100ɂĉB','',0);
    exit;
  end;
  if N < 3 then begin
    application.MessageBox('N3ȏɂĉB','',0);
    exit;
  end;
  result := N;
end;

// ObhNZbg
procedure TForm1.NsetBtnClick(Sender: TObject);
var
  N : integer;
begin
  N := Ninput(false);
  if N < 0 then exit;
  GridSet(N + 1, 3);
end;

// x̒l`FbN x̒l邩mF l true L false
function datacheck(x :DArray): boolean;
var
  i, j : integer;
begin
  result := True;
  for i := Low(x) to High(x) do
    for j := Low(x) to High(x) do begin
      if i <> j then
        if x[i] - x[j] = 0 then begin
          application.MessageBox(pchar('w' + inttostr(i+1) + ' w' + inttostr(j+1)
                                         + 'lłB'),'',0);
          result := False;
          exit;
        end;
    end;
end;

// ԌvZ
function interpolate(x, y: DArray; xx: double): double;
var
  i, j : integer;
  s, p : double;
begin
  s := 0;
  for i := Low(x) to High(x) do begin
    p := y[i];
    for j := Low(x) to High(x) do begin
      if i <> j then
        p := p * (xx - x[j]) / (x[i] - x[j]);
    end;
    s := s + p;
  end;
  result := s;
end;

// Qllf(x) QۊmFpf[^[
function f(x: double): double;
begin
//  x := abs(x);
  result := 1 / (1 + 2 * x * x);
end;

// Qll Zbg
procedure TForm1.testdataBtnClick(Sender: TObject);
var
  N, ch : integer;
  i : integer;
  p, minx, maxx :double;
  x, y : Darray;
  xd, yd : double;
begin
  Series1.Clear;
  Series3.Clear;
  FF := False;;
  N := 5;
  if radiogroup1.ItemIndex = 0 then begin
    N := 8;               // f[^[
    Nedit.Text := inttostr(N);
    GridSet(N + 1, 3);
    setlength(x, N);
    setlength(y, N);
    x[0] := -8; y[0] :=  2;
    x[1] := -5; y[1] :=  3;
    x[2] := -3; y[2] :=  1;
    x[3] :=  0; y[3] :=  2;
    x[4] :=  2; y[4] :=  1;
    x[5] :=  5; y[5] :=  3;
    x[6] :=  8; y[6] := -4;
    x[7] :=  9; y[7] :=  1;
  end;
  if radiogroup1.ItemIndex = 1 then begin
    N := 5;               // f[^[
    Nedit.Text := inttostr(N);
    GridSet(N + 1, 3);
    setlength(x, N);
    setlength(y, N);
    x[0] :=  0; y[0] :=  0.8;
    x[1] :=  2; y[1] :=  3.4;
    x[2] :=  3; y[2] :=  4.9;
    x[3] :=  4; y[3] :=  2.9;
    x[4] :=  5; y[4] :=  2;
  end;
  if (radiogroup1.ItemIndex = 0) or (radiogroup1.ItemIndex = 1) then
    for i := 0 to N - 1 do begin
      StringGrid1.cells[1,i + 1] := floatTostr(x[i]);
      StringGrid1.cells[2,i + 1] := floatTostr(y[i]);
    end;

  if radiogroup1.ItemIndex = 2 then begin
    N := Ninput(true);
    if N < 0 then exit;
    val(minxedit.Text, minx, ch);
    if ch <> 0 then begin
      application.MessageBox('MinlɊԈႢL܂B','',0);
      exit;
    end;
    val(maxxedit.Text, maxx, ch);
    if ch <> 0 then begin
      application.MessageBox('MaxlɊԈႢL܂B','',0);
      exit;
    end;
    if minx >= maxx then begin
      application.MessageBox('MaxlMinl菬łB','',0);
      exit;
    end;
    Nedit.Text := inttostr(N);
    GridSet(N + 1, 3);
    p := (maxx - minx) / (N - 1);
    for i := 0 to N - 1 do begin
      xd := i * p + minx;
      yd := f(xd);
      StringGrid1.cells[1,i + 1] := floatTostr(xd);
      StringGrid1.cells[2,i + 1] := floatTostr(yd);
    end;
    if checkbox2.Checked = True then FF := true;
  end;
  interpolationBtnClick(Nil);
end;

// Obh̒lɂԌvZ
procedure TForm1.interpolationBtnClick(Sender: TObject);
var
  ch, i, imax : integer;
  cn : string;
  s, xx : double;
begin
  XtoYBtn.Enabled := False;
  N := Ninput(false);
  if N < 0 then exit;
  GridSet(N + 1, 3);
  setlength(x, N);
  setlength(y, N);
  setlength(yd, N);
  for i := 0 to N - 1 do begin
    val(StringGrid1.cells[1,i + 1], x[i], ch);
    if ch <> 0 then begin
      cn := 'x' + intTostr(i + 1) + 'ɊԈႢL܂B';
      application.MessageBox(pchar(cn),'',0);
      break;
    end;
    val(StringGrid1.cells[2,i + 1], y[i], ch);
    if ch <> 0 then begin
      cn := 'y' + intTostr(i + 1) + 'ɊԈႢL܂B';
      application.MessageBox(pchar(cn),'',0);
      break;
    end;
  end;
  if ch <> 0 then exit;
  if not datacheck(x) then exit;            // x̒lɏdmF
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  xmin := x[0];
  xmax := x[0];
  for i := 0 to N - 1 do begin
    if x[i] > xmax then xmax := x[i];
    if x[i] < xmin then xmin := x[i];
    Series3.AddXY(x[i], y[i]);
    if FF then yd[i] := 1 / y[i]
          else yd[i] := y[i];
  end;
  imax := (N - 1) * 20;                     // 
  dx := (xmax - xmin) / imax;
  for i := 0 to imax do begin
    xx := i * dx + x[0];
    if radiogroup1.ItemIndex = 2 then begin
      s := f(xx);
      Series4.AddXY(xx, s);
    end;
    s := interpolate(x, yd, xx);             // ԌvZ
    if FF then s := 1  / s;
    Series1.AddXY(xx, s);
  end;
  XtoYBtn.Enabled := True;
end;

// wlOt\ wlxɂyԒlvZƃOt\
procedure TForm1.XtoYBtnClick(Sender: TObject);
var
  i, j, ch : integer;
  xd, s, xx, gmin, gmax : double;
begin
  val(Xedit.Text, xd, ch);
  if ch <> 0 then begin
    application.MessageBox('xY̓͂ɊԈႢL܂B','',0);
    exit;
  end;
  // ŏőԃOtĕ`
  Series1.Clear;
  gmin := xmin;
  gmax := xmax;
  if xd < xmin then gmin := xd;
  if xd > xmax then gmax := xd;
  i := round((gmax - gmin) / dx);
  for j := 0 to i do begin
    xx := j * dx + gmin;
    s := interpolate(x, yd, xx);            // ԌvZ
    if FF then s := 1  / s;
    Series1.AddXY(xx, s);
  end;
  // wlxɂyԒlvZƃOt\
  Series2.Clear;
  s := interpolate(x, yd, xd);              // ԌvZ
  if FF then s := 1  / s;
  Series2.AddXY(xd, s);
end;

// Obhݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  FGridSet(101, 3);                 // Œs11 + 100s2܂ōsύXĂ
                                    // ͒lNAȂ悤ɂ܂B
  GridSet(4, 3);                    // ŏ̐ݒ
end;

end.
